Message processing monitor

Barlas Solakoglu 
Transaction and Messaging Systems Specialist (Turkey)	c Xephon



CBL XOPTS(ANSI85)                                                       
CBL NODYNAM,LIB,OBJECT,RENT,RES,APOST                                   
       IDENTIFICATION DIVISION.                                         
       PROGRAM-ID. QMONHOST.                                            
      * MODULE NAME = QMONHOST                                        * 
      * ENVIRONMENT = CICS, COBOL II                                  *
      * CICS TRANSACTION NAME = QMON                                  *
      * DESCRIPTIVE NAME = Queue Monitor (QMON)                       * 
      * FUNCTION :                                                    *
      * DESCRIPTION :                                                 * 
      *   The Program uses a number of parameters defined in          *
      *   the working-storage section of this program. These          * 
      *   parameters are namelist name, MQ-NAMELIST-NAME and total    *
      *   number of queues in the namelist, TOTAL-QUEUE-NUMBER.       *
      *   Each queue is represented by a number, QUEUENO.             *
      *                     PROGRAM LOGIC                             *
      * START.                                                        *
      *   set transaction (QMON) to start 3 minutes later.            *
      *   get system time and write to time field of output message.  *
      *   check the QMON TSQ for existence.(READ-TSQ)                 *
      *   get name of the QManager.(GET-QMGR-NAME)                    *
      *   get queue names to be monitored from the namelist.          *
      *                                   (GET-QUEUE-NAMES)           *
      *   for each queue in the namelist                              *
      *      open queue(OPEN-APP-QUEUE)                               *
      *      inquire queue(INQUIRE-APP-QUEUE)                         *
      *      get "put enabled", "get enabled", "trigger set"          *
      *                                         information           *
      *      set put, get, trigger bit of output message              *
      *          (1->OK, 0->PROBLEM)                                  * 
      *      get "input use count", "output use count" and            *
      *          "queue depth"                                        *
      *      write "input use count", "output use count" and          *   
      *          "queue depth" to output message                      *
      *      browse first message in queue(GET-BROWSE-APP-QUEUE)      *
      *      close queue(CLOSE-APP-QUEUE)                             *
      *      read stored message id in TSQ(READ-TSQ)                  *
      *      compare browsed and stored message ids(COMPARE-MESSAGES) *
      *      if browsed and stored message ids are different          *
      *         messages in the queue are processed properly          *
      *         set status bit of output message "1"(OK)              *
      *         write browsed message id to TSQ(WRITE-TSQ)            * 
      *      else                                                     *
      *         first messages is not processed                       *
      *         set status bit of output message "0"(PROBLEM)         *
      *         write stored message id again to TSQ(WRITE-TSQ)       *
      *      end-if                                                   *
      *      if all bits(status, put, get and trigger bit) are "1"(OK)*
      *         set overall bit to "1" (OK)                           *
      *      else                                                     *
      *         set overall bit to "0" (PROBLEM)                      *
      *      end-if                                                   *
      *      open output queue(OPEN-OUTPUT-QUEUE)                     *
      *      put output message to output queue(PUT-OUTPUT-QUEUE)     *
      *      close output queue(CLOSE-OUTPUT-QUEUE)                   *
      *   end-for.                                                    *
      * END.                                                          *
       DATE-WRITTEN.  OCTOBER,     1998.                                
       DATE-COMPILED.                                                   
       ENVIRONMENT DIVISION.                                            
       CONFIGURATION SECTION.                                           
       SOURCE-COMPUTER. IBM-3090.                                       
       OBJECT-COMPUTER. IBM-3090.                                       
       INPUT-OUTPUT SECTION.                                            
       FILE-CONTROL.                                                    
       I-O-CONTROL.                                                     
       DATA DIVISION.                                                   
       FILE SECTION.                                                    
       WORKING-STORAGE SECTION.                                         
       01  QMGR-NAME                PICTURE X(48) VALUE SPACES.         
       01  MQ-OBJECTNAME            PICTURE X(48) VALUE SPACES.         
       01  MQ-HCONN                 PICTURE S9(9) BINARY VALUE ZERO.    
       01  MQ-OPTIONS               PICTURE S9(9) BINARY.               
       01  MQ-OUTPUT-Q-HOBJ         PICTURE S9(9) BINARY VALUE ZERO.    
       01  MQ-INPUT-Q-HOBJ          PICTURE S9(9) BINARY VALUE ZERO.    
       01  MQ-QUEUE-HOBJ            PICTURE S9(9) BINARY VALUE ZERO.    
       01  MQ-QMGR-HOBJ             PICTURE S9(9) BINARY VALUE ZERO.    
       01  MQ-COMPCODE              PICTURE S9(9) BINARY.               
       01  MQ-REASON                PICTURE S9(9) BINARY.               
       01  MQ-BUFFLEN               PICTURE S9(9) BINARY VALUE +3000.   
       01  MQ-DATALEN               PICTURE S9(9) BINARY.               
       01  MQ-GET-BUFFER            PICTURE X(3000) VALUE SPACES.       
       01  MQ-SELECTORCOUNT         PICTURE S9(9) BINARY VALUE 6.       
       01  MQ-SELECTORS-TABLE.                                          
           05  MQ-SELECTORS         PICTURE S9(9) BINARY OCCURS 6 TIMES.
       01  MQ-INTATTRCOUNT          PICTURE S9(9) BINARY VALUE 6.       
       01  MQ-INTATTRS-TABLE.                                           
           05  MQ-INTATTRS          PICTURE S9(9) BINARY OCCURS 6 TIMES.
       01  MQ-CHARATTRLENGTH-NLIST  PICTURE S9(9) BINARY VALUE 9600.    
       01  MQ-CHARATTRS-TABLE-NLIST.                                    
           05  MQ-CHARATTRS-NLIST   PIC X(48) OCCURS 100 TIMES.         
       01  MQ-CHARATTRLENGTH        PICTURE S9(9) BINARY VALUE 48.      
       01  MQ-CHARATTRS-TABLE.                                          
           05  MQ-CHARATTRS         PIC X(48) OCCURS 1   TIMES.         
      * MQ-NAMELIST-NAME is the name of the namelist containing names * 
      *                  of monitored queues.                         *       
       01  MQ-NAMELIST-NAME         PICTURE X(20)  VALUE                
                                    'QMON.NAMELIST'.                    
       01  MQ-HOBJ-NAMELIST         PICTURE S9(9) BINARY.                
       01  QNAME-TABLE-NLIST.                                           
           05  QNAME-NLIST          PIC X(48) OCCURS 100 TIMES.         
       01  LEN-MQ-ERROR-MESSAGE    PICTURE S9(4) COMP VALUE 87.         
     * ERROR MESSAGE STRUCTURE                                        *
           01  MQ-ERROR-MESSAGE.                                            
           05 YEAR-ERROR           PICTURE 9999.                        
           05 FILLER               PICTURE X VALUE '.'.                 
           05 MONTH-ERROR          PICTURE 99.                          
           05 FILLER               PICTURE X VALUE '.'.                 
           05 DAY-ERROR            PICTURE 99.                          
           05 FILLER               PICTURE X VALUE ' '.                 
           05 HOUR-ERROR           PICTURE 99.                          
           05 FILLER               PICTURE X VALUE ':'.                 
           05 MINUTE-ERROR         PICTURE 99.                          
           05 FILLER               PICTURE X VALUE ':'.                 
           05 SECOND-ERROR         PICTURE 99.                          
           05 FILLER               PICTURE X(7) VALUE ' QMON: '.        
           05 MQ-ERROR-OPERATION  PICTURE X(10) VALUE SPACES.           
           05 FILLER              PICTURE X(18) VALUE                   
                                   ' ERROR: COMPCODE: '.                
           05 MQ-ERROR-COMPCODE   PICTURE Z9.                           
           05 FILLER              PICTURE X(04) VALUE SPACES.           
           05 FILLER              PICTURE X(09) VALUE ' REASON: '.      
           05 MQ-ERROR-REASON     PICTURE Z(08)9.                       
       01  LEN-ABEND-MESSAGE       PICTURE S9(4) COMP VALUE 60.         
       01  ABEND-MESSAGE.                                               
           05  FILLER           PICTURE X(14) VALUE 'TRANSACTION : '.   
           05  ABEND-TRANS-ID   PICTURE X(4)  VALUE 'QMON'.             
           05  FILLER           PICTURE X(44) VALUE                     
                   ' ABNORMALLY ENDED                           '.      
       01  TSQ-MESSAGE-LEN     PIC S9(4)  COMP VALUE 72.            
      * TSQ contains items, which has a name same as Qname and        *
      *     the message id of the first message in this Queue         *
      *     for later comparison.                                     *
       01  TSQ-MESSAGE.                                                 
           05  Q-NAME           PICTURE X(48) VALUE ZEROS.              
           05  OLD-MSGID        PICTURE X(24) VALUE ZEROS.              
       01  GET-INT-BUFFER       PICTURE S9(9) COMP VALUE 0.             
       01  PUT-INT-BUFFER       PICTURE S9(9) COMP VALUE 0.             
       01  TRIGGER-INT-BUFFER   PICTURE S9(9) COMP VALUE 0.             
      01  MQ-PUT-BUFFER-LEN       PICTURE S9(9) COMP VALUE +52.        
      * MQ-PUT-BUFFER contains output message for each queue. This    * 
      *               structure is composed of queue number(QUEUENO), * 
      *               monitor time (YEAR-WORK, MONTH WORK, DAY-WORK,  * 
      *               HOUR-WORK, MINUTE-WORK, SECOND-WORK), overall   * 
      *               bit(OVERALL-BUFFER), status of the queue        * 
      *               (STATUS-BUFFER), put-enable bit(PUT-BUFFER),    *             
      *               get-enable bit(GET-BUFFER),trigger-set bit      *
      *               (TRIGGER-BUFFER), input use count               *
      *               (INPUT-USE-COUNT), output use count             *             
      *               (OUTPUT-USE-COUNT), queue depth(QDEPTH).        *             
       01  MQ-PUT-BUFFER.                                               
           05 QUEUENO              PICTURE 999.                         
           05 YEAR-WORK            PICTURE 9999.                        
           05 MONTH-WORK           PICTURE 99.                          
           05 DAY-WORK             PICTURE 99.                          
           05 HOUR-WORK            PICTURE 99.                          
           05 MINUTE-WORK          PICTURE 99.                          
           05 SECOND-WORK          PICTURE 99.                          
           05 OVERALL-BUFFER       PIC  X(1) VALUE '0'.                 
           05 STATUS-BUFFER        PIC  X(1) VALUE '0'.                 
           05 PUT-BUFFER           PIC  X(1) VALUE '0'.                 
           05 GET-BUFFER           PIC  X(1) VALUE '0'.                 
           05 TRIGGER-BUFFER       PIC  X(1) VALUE '0'.                 
           05 INPUT-USE-COUNT      PIC  X(9) VALUE '0'.                 
           05 OUTPUT-USE-COUNT     PIC  X(9) VALUE '0'.                 
           05 QDEPTH               PIC  X(9) VALUE '10'.                
       01  TIME-IN-MSEC        PICTURE S9(15)  COMP-3.                  
       01  DATE-SYSTEM.                                                 
           05  YEAR-SYSTEM     PICTURE 9999.                            
           05  MONTH-SYSTEM    PICTURE 99.                              
           05  DAY-SYSTEM      PICTURE 99.                              
       01  TIME-SYSTEM.                                                 
           05  HOUR-SYSTEM     PICTURE 99.                              
           05  MINUTE-SYSTEM   PICTURE 99.                              
           05  SECOND-SYSTEM   PICTURE 99.                              
           05  FILLER          PICTURE 99.                              
      * TOTAL-QUEUE-NUMBER is total queue number written in the       *         
      *                       namelist. This number is set            *         
      *                       automatically when namelist is read.    *         
       01  TOTAL-QUEUE-NUMBER   PICTURE 999   VALUE 100.                
       01  I                    PICTURE 999   COMP VALUE 1.             
       01  XXX                  PICTURE S9(8) COMP VALUE 0.             
       01  YYY                  PICTURE S9(8) COMP VALUE 0.             
      * MSGID-TABLE is filled with the message-ids of the first       *
      *       in each monitored queue. Number of monitored queues is  *
      *       assumed to be maximum 100.                              * 
       01  MSGID-TABLE.                                                 
           05  MSGID             PICTURE X(24) OCCURS 100 TIMES. 
      * ******* FLAG definitions                                      * 
       01  OPEN-QMGR-FLAG        PICTURE X     VALUE SPACE.             
           88  OPEN-QMGR-OK                    VALUE 'Y'.               
       01  CLOSE-QMGR-FLAG       PICTURE X     VALUE SPACE.             
           88  CLOSE-QMGR-OK                   VALUE 'Y'.               
       01  INQ-QMGR-FLAG         PICTURE X     VALUE SPACE.             
           88  INQ-QMGR-OK                     VALUE 'Y'.               
       01  INQ-NAMELIST-FLAG     PICTURE X     VALUE SPACE.             
           88  INQ-NAMELIST-OK                 VALUE 'Y'.               
       01  OPEN-NAMELIST-FLAG    PICTURE X     VALUE SPACE.             
           88  OPEN-NAMELIST-OK                VALUE 'Y'.               
       01  CLOSE-NAMELIST-FLAG   PICTURE X     VALUE SPACE.             
           88  CLOSE-NAMELIST-OK               VALUE 'Y'.               
       01  OPEN-QUEUE-FLAG       PICTURE X     VALUE SPACE.             
           88  OPEN-QUEUE-OK                   VALUE 'Y'.               
       01  INQ-QUEUE-FLAG        PICTURE X     VALUE SPACE.             
           88  INQ-QUEUE-OK                    VALUE 'Y'.               
       01  GET-QUEUE-FLAG        PICTURE X     VALUE SPACE.             
           88  GET-QUEUE-OK                    VALUE 'Y'.               
       01  CLOSE-QUEUE-FLAG      PICTURE X     VALUE SPACE.             
           88  CLOSE-QUEUE-OK                  VALUE 'Y'.               
       01  OPEN-OUTPUT-FLAG      PICTURE X     VALUE SPACE.             
           88  OPEN-OUTPUT-OK                   VALUE 'Y'.              
       01  PUT-OUTPUT-FLAG        PICTURE X     VALUE SPACE.            
           88  PUT-OUTPUT-OK                    VALUE 'Y'.              
       01  CLOSE-OUTPUT-FLAG      PICTURE X     VALUE SPACE.            
           88  CLOSE-OUTPUT-OK                  VALUE 'Y'.              
       01  READ-TSQ-FLAG          PICTURE X     VALUE SPACE.            
           88  READ-TSQ-OK                      VALUE 'Y'.              
       01  WRITE-TSQ-FLAG         PICTURE X     VALUE SPACE.            
           88  WRITE-TSQ-OK                     VALUE 'Y'.              
       01  COMPARE-MESSAGES-FLAG  PICTURE X     VALUE SPACE.            
           88  COMPARE-MESSAGES-OK              VALUE 'Y'.              
       01  DELETE-TSQ-FLAG         PICTURE X     VALUE SPACE.           
           88  DELETE-TSQ-OK                     VALUE 'Y'.             
      * ******* Data structures                                       * 
       01  MQM-OBJECT-DESCRIPTOR.                                       
           COPY CMQODV.                                                 
       01  MQM-MESSAGE-DESCRIPTOR.                                      
           COPY CMQMDV.                                                 
       01  MQM-GET-MESSAGE-OPTIONS.                                     
           COPY CMQGMOV.                                                
       01  MQM-PUT-MESSAGE-OPTIONS.                                     
           COPY CMQPMOV.                                                
       01  MQM-CONSTANTS.                                               
           COPY CMQV SUPPRESS.                                          
       LINKAGE SECTION.                                                 
       PROCEDURE DIVISION.                                              
       START-PROG.                                                      
           PERFORM INIT-PROG                                            
              THRU INIT-PROG-EXIT.                                      
           PERFORM MAIN-PROG                                            
              THRU MAIN-PROG-EXIT.                                      
           PERFORM END-PROG                                             
              THRU END-PROG-EXIT.                                       
       INIT-PROG.                                                       
           EXEC CICS HANDLE ABEND                                       
                     LABEL    (ABEND-PROC)                              
           END-EXEC.                                                    
      * Set transaction (QMON) start itself 3 minutes later.          * 
           EXEC CICS START INTERVAL(000300) TRANSID('QMON') END-EXEC.   
      * Get absolute time and convert it to a readable format         *
           PERFORM DATE-CONVERSION                                      
              THRU DATE-CONVERSION-EXIT.                               
           MOVE MQHC-DEF-HCONN TO MQ-HCONN.                             
       INIT-PROG-EXIT.                                                  
           EXIT.                                                        
       MAIN-PROG.                                                       
      * Check TSQ whether it exists properly.                         *
           PERFORM READ-TSQ                                             
              THRU READ-TSQ-EXIT.                                       
      * Get QManager name CICS is connected to.                       *
           PERFORM GET-QMGR-NAME                                        
              THRU GET-QMGR-NAME-EXIT.                                  
      * Get Queue names from namelist                                 *
           IF QMGR-NAME NOT = SPACES                                    
               PERFORM GET-QUEUE-NAMES                            
                  THRU GET-QUEUE-NAMES-EXIT                       
           ELSE                                                         
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
      * First queue is represented by number 10 in this program.      *
      * You can give any number as desired.                           *
      * (We used at least 2 digits number for compatibility with the  *
      * GUI program presenting the results of this program.)          *  
      * So QUEUENO is initialized to 9 at start.                      *  
           MOVE 9 TO QUEUENO.                                         
      * Procedure GET-ONE-MESSAGE gets information for each queue,    *
      * compares the message id of the first message in the queue with*
      * the message id of the first message 3 minutes before stored   *
      * to the TSQ. If they are same, so the first message in the     *
      * is not processed since 3 minutes.                             * 
      * Then the message for the status of the Queue is built and put *
      * to the output queue.                                          *
           PERFORM GET-ONE-MESSAGE                                      
               THRU GET-ONE-MESSAGE-EXIT                                
           VARYING I FROM 1 BY 1                                        
               UNTIL I > TOTAL-QUEUE-NUMBER.                            
       MAIN-PROG-EXIT.                                                  
           EXIT.                                                        
       GET-QMGR-NAME.                                                   
           MOVE SPACES TO QMGR-NAME.                                    
           PERFORM OPEN-QMGR                                            
              THRU OPEN-QMGR-EXIT.                                      
           IF OPEN-QMGR-OK                                              
               PERFORM INQ-QMGR                                         
                  THRU INQ-QMGR-EXIT                                    
               PERFORM CLOSE-QMGR                                       
                  THRU CLOSE-QMGR-EXIT.                                 
       GET-QMGR-NAME-EXIT.                                              
           EXIT.                                                        
       OPEN-QMGR.                                                       
           MOVE MQOT-Q-MGR               TO MQOD-OBJECTTYPE.            
           MOVE SPACES                   TO MQOD-OBJECTNAME.            
           MOVE SPACES                   TO MQOD-DYNAMICQNAME.          
           MOVE ZERO                     TO MQ-QMGR-HOBJ.               
           MOVE MQHC-DEF-HCONN           TO MQ-HCONN.                   
           MOVE MQOO-INQUIRE             TO MQ-OPTIONS.                 
           CALL 'MQOPEN' USING MQ-HCONN                                 
                               MQOD                                     
                               MQ-OPTIONS                               
                               MQ-QMGR-HOBJ                             
                               MQ-COMPCODE                              
                               MQ-REASON.                               
           IF (MQ-COMPCODE = MQCC-OK) THEN                              
               MOVE 'Y'  TO OPEN-QMGR-FLAG                              
           ELSE                                                         
               MOVE 'N'  TO OPEN-QMGR-FLAG                              
               MOVE 'MQOPEN  QM'    TO MQ-ERROR-OPERATION               
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       OPEN-QMGR-EXIT.                                                  
           EXIT.                                                        
       INQ-QMGR.                                                        
           MOVE 1                    TO MQ-SELECTORCOUNT.               
           MOVE 0                    TO MQ-INTATTRCOUNT.                
           MOVE MQCA-Q-MGR-NAME      TO MQ-SELECTORS(1).                
           MOVE MQ-Q-MGR-NAME-LENGTH TO MQ-CHARATTRLENGTH.              
          CALL 'MQINQ' USING MQ-HCONN                                  
                              MQ-QMGR-HOBJ                              
                              MQ-SELECTORCOUNT                          
                              MQ-SELECTORS-TABLE                        
                              MQ-INTATTRCOUNT                           
                              MQ-INTATTRS-TABLE                         
                              MQ-CHARATTRLENGTH                         
                              MQ-CHARATTRS-TABLE                        
                              MQ-COMPCODE                               
                              MQ-REASON.                                
           IF MQ-COMPCODE = MQCC-OK                                     
               MOVE 'Y'  TO INQ-QMGR-FLAG                               
               MOVE MQ-CHARATTRS(1) TO QMGR-NAME                        
           ELSE                                                         
               MOVE 'N'  TO INQ-QMGR-FLAG                               
               MOVE 'MQINQ   QM'    TO MQ-ERROR-OPERATION               
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       INQ-QMGR-EXIT.                                                   
           EXIT.                                                        
       CLOSE-QMGR.                                                      
           CALL 'MQCLOSE' USING MQ-HCONN                                
                                MQ-QMGR-HOBJ                            
                                MQCO-NONE                               
                                MQ-COMPCODE                             
                                MQ-REASON.                              
           IF (MQ-COMPCODE = MQCC-OK) THEN                              
               MOVE 'Y'  TO CLOSE-QMGR-FLAG                             
           ELSE                                                         
               MOVE 'N'  TO CLOSE-QMGR-FLAG                             
               MOVE 'MQCLOSE QM'  TO MQ-ERROR-OPERATION                 
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       CLOSE-QMGR-EXIT.                                                 
           EXIT.                                                        
       GET-QUEUE-NAMES.                                           
           PERFORM OPEN-NAMELIST                                        
              THRU OPEN-NAMELIST-EXIT.                                  
           IF MQ-COMPCODE = MQCC-OK                                     
               PERFORM INQ-NAMELIST                                     
                  THRU INQ-NAMELIST-EXIT                                
               IF INQ-NAMELIST-OK                                       
                   MOVE MQ-INTATTRS(1) TO TOTAL-QUEUE-NUMBER.           
               PERFORM CLOSE-NAMELIST                                   
                  THRU CLOSE-NAMELIST-EXIT.                             
       GET-QUEUE-NAMES-EXIT.                                      
           EXIT.                                                        
       OPEN-NAMELIST.                                                   
           MOVE MQOT-NAMELIST    TO MQOD-OBJECTTYPE.                    
           MOVE MQ-NAMELIST-NAME TO MQOD-OBJECTNAME.                    
           MOVE QMGR-NAME        TO MQOD-OBJECTQMGRNAME.                
           COMPUTE MQ-OPTIONS =  MQOO-INQUIRE.                          
           CALL 'MQOPEN' USING MQ-HCONN                                 
                               MQOD                                     
                               MQ-OPTIONS                               
                               MQ-HOBJ-NAMELIST                         
                               MQ-COMPCODE                              
                               MQ-REASON.                               
           IF (MQ-COMPCODE = MQCC-OK) THEN                              
               MOVE 'Y'  TO OPEN-NAMELIST-FLAG                          
           ELSE                                                         
               MOVE 'N'  TO OPEN-NAMELIST-FLAG                          
               MOVE 'MQOPEN  NL'  TO MQ-ERROR-OPERATION                 
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       OPEN-NAMELIST-EXIT.                                              
           EXIT.                                                        
       INQ-NAMELIST.                                                    
           MOVE 2 TO MQ-SELECTORCOUNT.                                  
           MOVE 1 TO MQ-INTATTRCOUNT.                                   
           MOVE MQIA-NAME-COUNT  TO MQ-SELECTORS(1).                    
           MOVE MQCA-NAMES       TO MQ-SELECTORS(2).                    
           CALL 'MQINQ' USING MQ-HCONN                                  
                              MQ-HOBJ-NAMELIST                          
                              MQ-SELECTORCOUNT                          
                              MQ-SELECTORS-TABLE                        
                              MQ-INTATTRCOUNT                           
                              MQ-INTATTRS-TABLE                         
                              MQ-CHARATTRLENGTH-NLIST                   
                              MQ-CHARATTRS-TABLE-NLIST                  
                              MQ-COMPCODE                               
                              MQ-REASON.                                
           IF (MQ-COMPCODE = MQCC-OK) THEN                              
               MOVE MQ-CHARATTRS-TABLE-NLIST TO QNAME-TABLE-NLIST       
               MOVE 'Y'  TO INQ-NAMELIST-FLAG                           
           ELSE                                                         
               MOVE 'N'  TO INQ-NAMELIST-FLAG                           
               MOVE 'MQINQ   NL'     TO MQ-ERROR-OPERATION              
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       INQ-NAMELIST-EXIT.                                               
           EXIT.                                                        
       CLOSE-NAMELIST.                                                  
           CALL 'MQCLOSE' USING MQ-HCONN                                
                                MQ-HOBJ-NAMELIST                        
                                MQCO-NONE                               
                                MQ-COMPCODE                             
                                MQ-REASON.                              
            IF (MQ-COMPCODE = MQCC-OK) THEN                              
               MOVE 'Y'  TO INQ-NAMELIST-FLAG                           
           ELSE                                                         
               MOVE 'N'  TO INQ-NAMELIST-FLAG                           
               MOVE 'MQCLOSE  NL'     TO MQ-ERROR-OPERATION             
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       CLOSE-NAMELIST-EXIT.                                             
           EXIT.                                                        
       GET-ONE-MESSAGE.                                                 
           PERFORM OPEN-APP-QUEUE                                       
              THRU OPEN-APP-QUEUE-EXIT.                                 
           PERFORM INQUIRE-APP-QUEUE                                    
              THRU INQUIRE-APP-QUEUE-EXIT.                              
           PERFORM GET-BROWSE-APP-QUEUE                                 
              THRU GET-BROWSE-APP-QUEUE-EXIT.                           
           PERFORM CLOSE-APP-QUEUE                                      
              THRU CLOSE-APP-QUEUE-EXIT.                                
           MOVE 'N'  TO COMPARE-MESSAGES-FLAG.                          
           COMPUTE QUEUENO = QUEUENO + 1.                               
           MOVE '0'                    TO STATUS-BUFFER.                
           MOVE '0'                    TO OVERALL-BUFFER.               
           IF READ-TSQ-OK THEN                                          
               PERFORM COMPARE-MESSAGES                                 
                  THRU COMPARE-MESSAGES-EXIT.                           
           PERFORM WRITE-TSQ                                            
              THRU WRITE-TSQ-EXIT.                                      
            PERFORM WRITE-MESSAGES                                      
               THRU WRITE-MESSAGES-EXIT.                                
       GET-ONE-MESSAGE-EXIT.                                            
           EXIT.                                                        
       COMPARE-MESSAGES.                                                
           PERFORM READ-TSQ                                             
              THRU READ-TSQ-EXIT.                                       
           MOVE 'N'  TO COMPARE-MESSAGES-FLAG.                          
           IF READ-TSQ-OK AND GET-QUEUE-OK                              
              IF ((OLD-MSGID = SPACES) AND (MSGID(I) = SPACES)) OR      
                  (OLD-MSGID NOT = MSGID(I)) THEN                       
                MOVE 'Y'  TO COMPARE-MESSAGES-FLAG.                     
       COMPARE-MESSAGES-EXIT.                                           
           EXIT.                                                        
       WRITE-MESSAGES.                                                  
           IF (COMPARE-MESSAGES-OK AND GET-QUEUE-OK) THEN               
               MOVE '1'                    TO STATUS-BUFFER             
           ELSE                                                         
               MOVE '0'                    TO STATUS-BUFFER.            
           IF ((STATUS-BUFFER = '1') AND (PUT-BUFFER = '1') AND         
               (GET-BUFFER = '1') AND (TRIGGER-BUFFER = '1')) THEN      
               MOVE '1'                    TO OVERALL-BUFFER.           
           PERFORM PUT-MESSAGES                                         
               THRU PUT-MESSAGES-EXIT.                                  
       WRITE-MESSAGES-EXIT.                                             
           EXIT.                                                        
       OPEN-APP-QUEUE.                                                  
            MOVE MQOT-Q                 TO MQOD-OBJECTTYPE.             
            MOVE MQ-CHARATTRS-NLIST(I)  TO MQOD-OBJECTNAME.             
            MOVE QMGR-NAME              TO MQOD-OBJECTQMGRNAME.         
            MOVE ZEROS                  TO MQ-QUEUE-HOBJ.               
            COMPUTE MQ-OPTIONS = MQOO-INQUIRE                           
                               + MQOO-BROWSE.                           
            CALL 'MQOPEN' USING MQ-HCONN                                
                                MQOD                                    
                                MQ-OPTIONS                              
                                MQ-QUEUE-HOBJ                           
                                MQ-COMPCODE                             
                                MQ-REASON.                              
            IF MQ-COMPCODE = MQCC-OK                                    
                MOVE 'Y'  TO OPEN-QUEUE-FLAG                            
            ELSE                                                        
                MOVE 'N'  TO OPEN-QUEUE-FLAG                            
                MOVE 'MQOPEN  Q '  TO MQ-ERROR-OPERATION                
                PERFORM HANDLE-ERROR                                    
                   THRU HANDLE-ERROR-EXIT.                              
       OPEN-APP-QUEUE-EXIT.                                             
           EXIT.                                                        
       INQUIRE-APP-QUEUE.                                               
           MOVE 6 TO MQ-SELECTORCOUNT.                                  
           MOVE 6 TO MQ-INTATTRCOUNT.                                   
           MOVE MQIA-CURRENT-Q-DEPTH TO MQ-SELECTORS(4).                
           MOVE MQIA-INHIBIT-GET     TO MQ-SELECTORS(1).                
           MOVE MQIA-INHIBIT-PUT     TO MQ-SELECTORS(2).                
           MOVE MQIA-TRIGGER-CONTROL TO MQ-SELECTORS(3).                
           MOVE MQIA-OPEN-INPUT-COUNT TO MQ-SELECTORS(5).               
           MOVE MQIA-OPEN-OUTPUT-COUNT TO MQ-SELECTORS(6).              
           CALL 'MQINQ' USING MQ-HCONN                                  
                              MQ-QUEUE-HOBJ                             
                              MQ-SELECTORCOUNT                          
                              MQ-SELECTORS-TABLE                        
                              MQ-INTATTRCOUNT                           
                              MQ-INTATTRS-TABLE                         
                              MQ-CHARATTRLENGTH                         
                              MQ-CHARATTRS-TABLE                        
                              MQ-COMPCODE                               
                              MQ-REASON.                                
           MOVE '0'         TO GET-BUFFER.                              
           MOVE '0'         TO PUT-BUFFER.                              
           MOVE '0'         TO TRIGGER-BUFFER.                          
           MOVE '0'         TO QDEPTH.                                  
           MOVE '9'         TO INPUT-USE-COUNT.                         
           MOVE '9'         TO OUTPUT-USE-COUNT.                        
           IF MQ-COMPCODE = MQCC-OK                                     
               MOVE 'Y'            TO INQ-QUEUE-FLAG                    
               MOVE MQ-INTATTRS(1) TO GET-INT-BUFFER                    
               MOVE MQ-INTATTRS(2) TO PUT-INT-BUFFER                    
               MOVE MQ-INTATTRS(3) TO TRIGGER-INT-BUFFER                
               MOVE MQ-INTATTRS(4) TO QDEPTH                            
               MOVE MQ-INTATTRS(5) TO INPUT-USE-COUNT                   
               MOVE MQ-INTATTRS(6) TO OUTPUT-USE-COUNT                  
               IF PUT-INT-BUFFER = 0 THEN                               
                  MOVE '1'         TO PUT-BUFFER                        
               END-IF                                                   
               IF TRIGGER-INT-BUFFER = 1 THEN                           
                  MOVE '1'         TO TRIGGER-BUFFER                    
               END-IF                                                   
               IF GET-INT-BUFFER = 0 THEN                               
                  MOVE '1'         TO GET-BUFFER                        
               END-IF                                                   
           ELSE                                                         
               MOVE 'N'           TO INQ-QUEUE-FLAG                     
               MOVE 'MQINQ    Q'  TO MQ-ERROR-OPERATION                 
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT.                               
       INQUIRE-APP-QUEUE-EXIT.                                          
           EXIT.                                                        
       GET-BROWSE-APP-QUEUE.                                            
           COMPUTE MQGMO-OPTIONS = MQGMO-ACCEPT-TRUNCATED-MSG +         
                                   MQGMO-BROWSE-FIRST.                  
           MOVE MQMI-NONE TO MQMD-MSGID.                                
           MOVE MQCI-NONE TO MQMD-CORRELID.                             
           CALL 'MQGET' USING MQ-HCONN                                  
                              MQ-QUEUE-HOBJ                             
                              MQMD                                      
                              MQGMO                                     
                              MQ-BUFFLEN                                
                              MQ-GET-BUFFER                             
                              MQ-DATALEN                                
                              MQ-COMPCODE                               
                              MQ-REASON.                                
           IF (MQ-COMPCODE = MQCC-OK) OR                                
              (MQ-REASON = MQRC-TRUNCATED-MSG-ACCEPTED) THEN            
               MOVE MQMD-MSGID             TO MSGID(I)                  
               MOVE 'Y'                    TO GET-QUEUE-FLAG            
           ELSE                                                         
               IF (MQ-REASON = MQRC-NO-MSG-AVAILABLE)                   
                   MOVE SPACES        TO MSGID(I)                       
                   MOVE 'Y'           TO GET-QUEUE-FLAG                 
               ELSE                                                     
                   MOVE 'N'           TO GET-QUEUE-FLAG                 
                   MOVE '2222'        TO MSGID(I)                       
                   MOVE 'MQGET    Q'  TO MQ-ERROR-OPERATION             
                   PERFORM HANDLE-ERROR                                 
                      THRU HANDLE-ERROR-EXIT.                           
       GET-BROWSE-APP-QUEUE-EXIT.                                       
           EXIT.                                                        
       CLOSE-APP-QUEUE.                                                 
           CALL 'MQCLOSE' USING MQ-HCONN                                
                                MQ-QUEUE-HOBJ                           
                                MQCO-NONE                               
                                MQ-COMPCODE                             
                                MQ-REASON.                              
           IF MQ-COMPCODE = MQCC-OK                                     
               MOVE 'Y' TO CLOSE-QUEUE-FLAG                             
           ELSE                                                         
               MOVE 'N' TO CLOSE-QUEUE-FLAG                             
               MOVE 'MQCLOSE Q '  TO MQ-ERROR-OPERATION                 
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT.                               
       CLOSE-APP-QUEUE-EXIT.                                            
           EXIT.                                                        
       READ-TSQ.                                                        
           EXEC CICS READQ TS QUEUE('QMON') INTO(TSQ-MESSAGE)           
                     ITEM(I) RESP(XXX)                                  
           END-EXEC.                                                    
           IF ( XXX = DFHRESP(ITEMERR) ) OR (XXX = DFHRESP(QIDERR) )    
                PERFORM DELETE-TSQ                                      
                   THRU DELETE-TSQ-EXIT                                 
                MOVE 'N'  TO READ-TSQ-FLAG                              
                MOVE 'READTSQ  E'  TO MQ-ERROR-OPERATION                
                PERFORM HANDLE-ERROR                                    
                   THRU HANDLE-ERROR-EXIT                               
           ELSE                                                         
                MOVE 'Y'  TO READ-TSQ-FLAG.                             
       READ-TSQ-EXIT.                                                   
           EXIT.                                                        
       DELETE-TSQ.                                                      
           EXEC CICS DELETEQ TS QUEUE('QMON') RESP(YYY)                 
           END-EXEC.                                                    
           IF (YYY = DFHRESP(QIDERR)) THEN                              
                MOVE 'N'  TO DELETE-TSQ-FLAG                            
                MOVE 'DELETETSQE'  TO MQ-ERROR-OPERATION                
                PERFORM HANDLE-ERROR                                    
                   THRU HANDLE-ERROR-EXIT                               
           ELSE                                                         
                MOVE 'Y'  TO DELETE-TSQ-FLAG.                           
       DELETE-TSQ-EXIT.                                                 
           EXIT.                                                        
       WRITE-TSQ.                                                       
          MOVE QNAME-NLIST(I)         TO Q-NAME.                       
           MOVE MSGID(I)               TO OLD-MSGID.                    
           IF READ-TSQ-OK THEN                                          
               EXEC CICS WRITEQ TS QUEUE('QMON') FROM(TSQ-MESSAGE)      
                            ITEM(I) REWRITE RESP(XXX)                   
               END-EXEC                                                 
           ELSE                                                         
               EXEC CICS WRITEQ TS QUEUE('QMON') FROM(TSQ-MESSAGE)      
                            ITEM(I) RESP(XXX)                           
               END-EXEC.                                                
           IF XXX = DFHRESP(ITEMERR) THEN                               
                MOVE 'N'  TO WRITE-TSQ-FLAG                             
                MOVE 'WRITETSQE'  TO MQ-ERROR-OPERATION                 
                PERFORM HANDLE-ERROR                                    
                   THRU HANDLE-ERROR-EXIT                               
           ELSE                                                         
                MOVE 'Y'  TO WRITE-TSQ-FLAG.                            
       WRITE-TSQ-EXIT.                                                  
           EXIT.                                                        
       PUT-MESSAGES.                                                    
           PERFORM OPEN-OUTPUT-QUEUE                                    
              THRU OPEN-OUTPUT-QUEUE-EXIT.                              
           PERFORM PUT-OUTPUT-QUEUE                                     
              THRU PUT-OUTPUT-QUEUE-EXIT.                               
           PERFORM CLOSE-OUTPUT-QUEUE                                   
              THRU CLOSE-OUTPUT-QUEUE-EXIT.                             
       PUT-MESSAGES-EXIT.                                               
           EXIT.                                                        
       OPEN-OUTPUT-QUEUE.                                               
            MOVE MQOT-Q                 TO MQOD-OBJECTTYPE.             
            MOVE 'CMON'                 TO MQOD-OBJECTNAME.             
            MOVE QMGR-NAME              TO MQOD-OBJECTQMGRNAME.         
            MOVE ZEROS                  TO MQ-QUEUE-HOBJ.               
            COMPUTE MQ-OPTIONS = MQOO-OUTPUT.                           
            CALL 'MQOPEN' USING MQ-HCONN                                
                                MQOD                                    
                                MQ-OPTIONS                              
                                MQ-QUEUE-HOBJ                           
                                MQ-COMPCODE                             
                                MQ-REASON.                              
            IF MQ-COMPCODE = MQCC-OK                                    
                MOVE 'Y'  TO OPEN-OUTPUT-FLAG                           
            ELSE                                                        
                MOVE 'N'  TO OPEN-OUTPUT-FLAG                           
                MOVE 'MQOPEN OQ '  TO MQ-ERROR-OPERATION                
                PERFORM HANDLE-ERROR                                    
                   THRU HANDLE-ERROR-EXIT                               
                PERFORM END-PROG                                        
                   THRU END-PROG-EXIT.                                  
       OPEN-OUTPUT-QUEUE-EXIT.                                          
           EXIT.                                                        
       PUT-OUTPUT-QUEUE.                                                
           MOVE MQMI-NONE TO MQMD-MSGID.                                
           MOVE MQCI-NONE TO MQMD-CORRELID.                             
           MOVE MQFMT-STRING TO MQMD-FORMAT.                            
           COMPUTE MQPMO-OPTIONS     = MQPMO-SYNCPOINT +                
                                       MQPMO-FAIL-IF-QUIESCING.         
           CALL 'MQPUT' USING  MQ-HCONN                                 
                               MQ-QUEUE-HOBJ                            
                               MQMD                                     
                               MQPMO                                    
                               MQ-PUT-BUFFER-LEN                        
                               MQ-PUT-BUFFER                            
                               MQ-COMPCODE                              
                               MQ-REASON.                               
              IF MQ-COMPCODE = MQCC-OK                                  
                  MOVE 'Y'               TO PUT-OUTPUT-FLAG             
              ELSE                                                      
                  MOVE 'N'               TO PUT-OUTPUT-FLAG             
                  MOVE 'MQPUT  OQ '      TO MQ-ERROR-OPERATION          
                  PERFORM HANDLE-ERROR                                  
                     THRU HANDLE-ERROR-EXIT                             
                  EXEC CICS SYNCPOINT ROLLBACK END-EXEC                 
                  PERFORM END-PROG                                      
                     THRU END-PROG-EXIT.                                
       PUT-OUTPUT-QUEUE-EXIT.                                           
           EXIT.                                                        
       CLOSE-OUTPUT-QUEUE.                                              
           CALL 'MQCLOSE' USING MQ-HCONN                                
                                MQ-QUEUE-HOBJ                           
                                MQCO-NONE                               
                                MQ-COMPCODE                             
                                MQ-REASON.                              
           IF MQ-COMPCODE = MQCC-OK                                     
               MOVE 'Y' TO CLOSE-OUTPUT-FLAG                            
           ELSE                                                         
               MOVE 'N' TO CLOSE-OUTPUT-FLAG                            
               MOVE 'MQCLOSEOQ '  TO MQ-ERROR-OPERATION                 
               PERFORM HANDLE-ERROR                                     
                  THRU HANDLE-ERROR-EXIT                                
                  EXEC CICS SYNCPOINT ROLLBACK END-EXEC                 
               PERFORM END-PROG                                         
                  THRU END-PROG-EXIT.                                   
       CLOSE-OUTPUT-QUEUE-EXIT.                                         
           EXIT.                                                        
       END-PROG.                                                        
           EXEC CICS RETURN END-EXEC.                                   
           STOP RUN.                                                    
       END-PROG-EXIT.                                                   
           EXIT.                                                        
       DATE-CONVERSION.                                                 
           EXEC CICS ASKTIME ABSTIME (TIME-IN-MSEC) END-EXEC.           
           EXEC CICS FORMATTIME ABSTIME (TIME-IN-MSEC)                  
                                YYYYMMDD (DATE-SYSTEM)                  
                                    TIME (TIME-SYSTEM)                  
           END-EXEC.                                                    
           MOVE DAY-SYSTEM     TO DAY-WORK.                             
           MOVE MONTH-SYSTEM   TO MONTH-WORK.                           
           MOVE YEAR-SYSTEM    TO YEAR-WORK.                            
           MOVE HOUR-SYSTEM    TO HOUR-WORK.                            
           MOVE MINUTE-SYSTEM  TO MINUTE-WORK.                          
           MOVE SECOND-SYSTEM  TO SECOND-WORK.                          
           MOVE DAY-SYSTEM     TO DAY-ERROR.                            
           MOVE MONTH-SYSTEM   TO MONTH-ERROR.                          
           MOVE YEAR-SYSTEM    TO YEAR-ERROR.                           
           MOVE HOUR-SYSTEM    TO HOUR-ERROR.                           
           MOVE MINUTE-SYSTEM  TO MINUTE-ERROR.                         
           MOVE SECOND-SYSTEM  TO SECOND-ERROR.                         
       DATE-CONVERSION-EXIT.                                            
            EXIT.                                                       
       ABEND-PROC. 
      * Error messages during the processing of this program    *
      * are written to a specific Cics TDQ TSSL.                *
           EXEC CICS WRITEQ TD QUEUE('TSSL') FROM(ABEND-MESSAGE)        
                            LENGTH(LEN-ABEND-MESSAGE) END-EXEC.         
           PERFORM END-PROG                                             
               THRU END-PROG-EXIT.                                      
       ABEND-PROC-EXIT.                                                 
           EXIT.                                                        
       HANDLE-ERROR.                                                    
           MOVE MQ-COMPCODE   TO MQ-ERROR-COMPCODE.                     
           MOVE MQ-REASON     TO MQ-ERROR-REASON.                       
           EXEC CICS WRITEQ TD QUEUE('CKMQ') FROM(MQ-ERROR-MESSAGE)     
                            LENGTH(LEN-MQ-ERROR-MESSAGE) END-EXEC.      
       HANDLE-ERROR-EXIT.                                               
           EXIT.                          

